Index: GUIListControl.cs
===================================================================
--- GUIListControl.cs	(revision 26455)
+++ GUIListControl.cs	(working copy)
@@ -270,6 +270,9 @@
     protected int _lastSearchItem = 0;
     protected bool _enableSMSsearch = true;
 
+    private DateTime _scrollTimer = DateTime.Now;
+    protected string _scrollDirection = "";
+
     public GUIListControl(int dwParentID)
       : base(dwParentID) { }
 
@@ -628,6 +631,10 @@
 
     protected virtual void RenderLabel(float timePassed, int buttonNr, int dwPosX, int dwPosY, bool gotFocus)
     {
+      GUIListItem scrollItem = SelectedListItem;
+      string firstChar = scrollItem.Label.Substring(0, 1).ToUpper();
+      GUIPropertyManager.SetProperty("#selecteditem.firstchar", firstChar);
+
       GUIListItem pItem = _listItems[buttonNr + _offset];
       long dwColor = _textColor;
       if (pItem.Shaded)
@@ -1054,6 +1061,17 @@
 
       RenderScrollbar(timePassed, dwPosY);
 
+      TimeSpan ts = DateTime.Now - _scrollTimer;
+      if (ts.TotalMilliseconds < 100) //how close keypresses should be before it triggers the label showing
+      {
+        GUIPropertyManager.SetProperty("#scrolling." + _scrollDirection, "yes");
+      }
+      else
+      {
+        GUIPropertyManager.SetProperty("#scrolling.up", "no");
+        GUIPropertyManager.SetProperty("#scrolling.down", "no");
+      }
+
       if (Focus)
       {
         GUIPropertyManager.SetProperty("#highlightedbutton", string.Empty);
@@ -2416,6 +2434,8 @@
           _cursorX--;
           _upDownControl.Value = ((_offset + _cursorX) / _itemsPerPage) + 1;
           OnSelectionChanged();
+          _scrollDirection = "up";
+          _scrollTimer = DateTime.Now;
         }
         else if (_cursorX <= _scrollStartOffset && _offset > 0)
         {
@@ -2430,6 +2450,8 @@
           }
           _upDownControl.Value = iPage;
           OnSelectionChanged();
+          _scrollDirection = "up";
+          _scrollTimer = DateTime.Now;
         }
         else
         {
@@ -2495,6 +2517,8 @@
             }
             _upDownControl.Value = ((_offset + _cursorX) / _itemsPerPage) + 1;
             OnSelectionChanged();
+            _scrollDirection = "down";
+            _scrollTimer = DateTime.Now;
           }
           else
           {
@@ -2532,6 +2556,8 @@
             }
             _upDownControl.Value = iPage;
             OnSelectionChanged();
+            _scrollDirection = "down";
+            _scrollTimer = DateTime.Now;
           }
           else
           {
